<!DOCTYPE html>
    <head>
    <meta charset="utf-8">

    <script src="https://code.jquery.com/jquery-3.1.0.min.js" integrity="sha256-cCueBR6CsyA4/9szpPfrX3s49M9vUU5BgtiJj06wt/s=" crossorigin="anonymous"></script>

    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
    <script type="text/javascript" src="js/d3.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>
    <script type="text/javascript" src="js/autocomplete.js"></script>

    <link rel="stylesheet" href="css/fonts/bariol/bariol.css"/>
    <link rel="stylesheet" href="css/style.css"/>
    <link rel="stylesheet" href="css/style2.css"/>
    <style>
    body {
      font: 10px sans-serif;
    }
    .axis path,
    .axis line {
      fill: none;
      stroke: #000;
      shape-rendering: crispEdges;
    }
    .point {
      fill: none;
      stroke: lightgrey;
      opacity:.1;
    }
    .red {
      fill: red;
      stroke: black;
      z-index:10;
    }
    .info {
        float:left;
        width:200px;
    }
    </style>
</head>
    <body>
        <div class="info">
            <h4>2D Tensor Comparison</h4>
            <p><b>1. Select tensor:</b>
                <select name="tensor" id="tensor">
                    <option value="0">--- select ---</option>
                    <option value="w1-s2-mc5">w1-s2-mc5</option>
                    <option value="w1-s2-mc30">w1-s2-mc30</option>
                    <option value="w2-s2-mc5">w2-s2-mc5</option>
                    <option value="w2-s2-mc30">w2-s2-mc30</option>
                    <option value="w4-s2-mc5">w4-s2-mc5</option>
                    <option value="w4-s2-mc30">w4-s2-mc30</option>
                    <option value="w8-s2-mc5">w8-s2-mc5</option>
                    <option value="w8-s2-mc30">w8-s2-mc30</option>
                    <option value="w16-s2-mc5">w16-s2-mc5</option>
                    <option value="w16-s2-mc30">w16-s2-mc30</option>
                    <option value="w32-s2-mc5">w32-s2-mc5</option>
                    <option value="w32-s2-mc30">w32-s2-mc30</option>
                    <option value="w64-s2-mc5">w64-s2-mc5</option>
                    <option value="w64-s2-mc30">w64-s2-mc30</option>
                </select>
            </p>
            <p>(w = window size | s = size (num features) | mc = min count (min term frequency in the corpora
                <br />mc=30 -> 16005 terms
                <br />mc=5  -> 58524 terms
            </p>
            <p>&nbsp;</p>
            <p><b>2. Show terms from topic models</b> (<a href="data/topics/glaucoma-keys.csv" target="_topicmodelfile">see topic model file</a>):
              <select name="indexTerms" id="indexTerms">
                <option value="-1" slected>--- select ---</option>
                <option value="0">0</option>
                <option value="1">1</option>
                <option value="2">2</option>
                <option value="3">3</option>
                <option value="4">4</option>
                <option value="5">5</option>
                <option value="6">6</option>
                <option value="7">7</option>
                <option value="8">8</option>
                <option value="9">9</option>
                <option value="10">10</option>
                <option value="11">11</option>
                <option value="12">12</option>
                <option value="13">13</option>
                <option value="14">14</option>
                <option value="15">15</option>
                <option value="16">16</option>
                <option value="17">17</option>
                <option value="18">18</option>
                <option value="19">19</option>
              </select>
        </p>
        <p id="listterms">&nbsp;</p>
        </div>
        <div style="clear:both;"></div>
        <div><p><b>3. Draw arrows between terms</b> (autocompleter with terms for mc=30)</p></div>
        <div id="term1" style="float:left;"></div>
        <div id="action" style="float:left;width:60px;padding:10px;padding-top:20px;">-></div>
        <div id="term2" style="float:left;"></div>
        <button id="doVector" type="button" class="btn btn-primary" style="float:left;padding:4px;">draw</button>

        <script language="JavaScript">

            //Variable to hold autocomplete options
            var keys;

            //Load US States as options from CSV - but this can also be created dynamically
            d3.csv("terms.csv",function (csv) {
                keys=csv;
                start();
            });


            //Call back for when user selects an option
            function onSelect(d) {
                //alert(d.State);
                console.log("d.State")
                // ToDoL check whether both fields are not empty. And Active/ deactivate draw button.
            }

            //Setup and render the autocomplete
            function start() {
                var mc = autocomplete(document.getElementById('term1'))
                        .keys(keys)
                        .dataField("Terms")
                        .placeHolder("Search terms typing here")
                        .width(400)
                        .height(500)
                        .onSelected(onSelect)
                        .render();
                var mc = autocomplete(document.getElementById('term2'))
                        .keys(keys)
                        .dataField("Terms")
                        .placeHolder("Search terms typing here")
                        .width(400)
                        .height(500)
                        .onSelected(onSelect)
                        .render();

            }


        </script>

<!-- ####################################################### -->


    <script>
    var margin = {top: 20, right: 20, bottom: 30, left: 40},
        width = 960 - margin.left - margin.right,
        height = 500 - margin.top - margin.bottom;
    var x = d3.scale.linear()
        .range([0, width]);
    var y = d3.scale.linear()
        .range([height, 0]);
    var svg = d3.select("body").append("svg")
        .attr("width", width + margin.left + margin.right)
        .attr("height", height + margin.top + margin.bottom)
      .append("g")
        .attr("transform", "translate(" + margin.left + "," + margin.top + ")");

    var tensor = "";
    $("#tensor").on("change", function() {
        tensor = "medline-with-abs-"+this.value+"-tensor.txt"
        console.log(indexTerms);
        doNewTensor(tensor);
    });

    function doNewTensor(tensor) {
        // Get the data in tsv
        //d3.tsv("data/medline-with-abs-w1-s2-mc30-tensor.txt", function(data) {
        d3.tsv("data/"+tensor, function(data) {
          //if (error) throw error;
          // Coerce the data to numbers.
          data.forEach(function(d,i) {
              if (i!=0) {
                  d.x = +d.x;
                  d.y = +d.y;
              }
          });
          // Compute the scales’ domains.
          x.domain(d3.extent(data, function(d) { return d.x; })).nice();
          y.domain(d3.extent(data, function(d) { return d.y; })).nice();
          // Add the x-axis.
          svg.append("g")
              .attr("class", "x axis")
              .attr("transform", "translate(0," + height + ")")
              .call(d3.svg.axis().scale(x).orient("bottom"));
          // Add the y-axis.
          svg.append("g")
              .attr("class", "y axis")
              .call(d3.svg.axis().scale(y).orient("left"));

              var indexTerms = 0;
              $("#indexTerms").on("change", function() {
                indexTerms = this.value;
                console.log(indexTerms);
                doNewTerms(indexTerms);
              });

              function doNewTerms(indexTerms) {
                    var newTerms = [];
                    d3.csv("data/topics/glaucoma-keys.csv", function(dataNewTerms) {
                        for(var propt in dataNewTerms[indexTerms]){
                            newTerms.push(dataNewTerms[indexTerms][propt]);
                        }
                        // Add topic terms to a div:
                        $("#listterms").html(newTerms.join(", "));

                        // moveToFront() function [https://gist.github.com/trtg/3922684]:
                        d3.selection.prototype.moveToFront = function() {
                          return this.each(function(){
                              this.parentNode.appendChild(this);
                          });
                        };
                        // Highlighting circles
                        svg.selectAll("circle").attr("class", function(d){
                              if (newTerms.indexOf(d.term) > -1) {
                                  color = "red";
                                  d3.select("#"+d.term).moveToFront();
                              } else {
                                  color = "point";
                              }
                              return color;
                        });
                    });
              }
          // Create line
         // var term1 = "document",
        //  term2 = "doctor";

              // Draw function
              $("#doVector").click(function(){
                  var term1 = $("#term1").find("input").val();
                  var term2 = $("#term2").find("input").val();
                  console.log("button clicked!");

                  var xTerm1 = svg.select("#" + term1).attr("cx"),
                      yTerm1 = svg.select("#" + term1).attr("cy");

                  var xTerm2 = svg.select("#" + term2).attr("cx"),
                      yTerm2 = svg.select("#" + term2).attr("cy");

                  svg.append("line")
                      .attr("x1",  xTerm1)
                      .attr("y1",  yTerm1)
                      .attr("x2",  xTerm2)
                      .attr("y2",  yTerm2)

                      .attr("stroke-width", 1)
                      .attr("stroke", "red")
                      .attr("marker-end", "url(#triangle)");

                });
            });
    }

    </script>
